/***************************************************************************
 *
 *                    RELATIONAL DATABASE SYSTEMS, INC.
 *
 *  COPYRIGHT (c) 1981-1986 RELATIONAL DATABASE SYSTEMS, INC., PALO ALTO, 
 *  CALIFORNIA.  All rights reserved.  No part of this work covered by the 
 *  copyright hereon may be reproduced or used in any form or by any means 
 *  -- graphic, electronic, or mechanical, including photocopying, 
 *     recording, taping, or information storage and retrieval systems --
 *  without permission of RDS.
 *
 *  Title:	sqlhdr.h
 *  Sccsid:	@(#)sqlhdr.h	4.8	12/8/86	17:31:29
 *  Description:
 *		header file for all embedded sql programs
 *
 ***************************************************************************
 */

#ifndef _SQLHDR
#define _SQLHDR

#include "sqlda.h"
 

typedef struct 
    {
    short _SQCstmttype;			/* SQ_SELECT, SQ_INSERT, etc. */
    short _SQCsqlid;			/* SQL's id for this cursor */
    short _SQCflags;			/* CROPEN, CREOF, CRSINGLE ,CRPREPARE*/
    short _SQCnfields;			/* number of result fields
					 * (number supplied by SQL)
					 */
    short _SQCnibind;			/* number of input args */
    short _SQCnobind;			/* number of output args */
    short _SQCtupcnt;			/* tuples remaining in buffer */
    short _SQCtupsize;			/* length of data expected from
					 * SQL
					 */
    struct sqlvar_struct *_SQCibind;	/* pointer to first in array of 
					 * binding structures for arguments
					 * to be taken from the user
					 * program and sent to SQL;
					 */
    struct sqlvar_struct *_SQCobind;	/* pointer to first in array of
					 * binding structures for values
					 * to be received from SQL and
					 * supplied to the user program;
					 */
    char **_SQCcommand;			/* pointer to ptrs to pieces of
					 * the command 
					 */
    struct sqlvar_struct *_SQCfields;	/* pointer to first in array of
					 * structures describing the data
					 * to be received from SQL;
					 * (fields described by SQL)
					 */
    char *_SQCstrtab;			/* pointer to table of strings - the
					 * names of the attributes to be
					 * received from SQL
					 * (table supplied by SQL)
					 */
    char *_SQCtbuf;			/* tuple buffer */
    char *_SQCtuple;			/* pointer to current tuple within
					 * buffer
					 */
    char *_SQCname;			/* cursor name */
    struct sqlda  *_SQCsqlda;		/* pointer to sqlda */

		/* used for scroll cursors */
    long _SQCfirst;			/* rowid of 1st tuple in buffer */
    long _SQClast;			/* rowid of last tuple in buffer */
    } _SQCURSOR;


typedef struct 
    {
    short _SQSstmttype;			/* SQ_SELECT, SQ_INSERT, etc. */
    short _SQSsqlid;			/* SQL's id for this cursor */
    } _SQSTMT;

#endif	/* _SQLHDR */
