/***************************************************************************
 *
 *                    RELATIONAL DATABASE SYSTEMS, INC.
 *
 *  COPYRIGHT (c) 1981-1986 RELATIONAL DATABASE SYSTEMS, INC., PALO ALTO, 
 *  CALIFORNIA.  All rights reserved.  No part of this work covered by the 
 *  copyright hereon may be reproduced or used in any form or by any means 
 *  -- graphic, electronic, or mechanical, including photocopying, 
 *     recording, taping, or information storage and retrieval systems --
 *  without permission of RDS.
 *
 *  Title:	sqltypes.h
 *  Sccsid:	@(#)sqltypes.h	4.5	11/24/86  15:41:43
 *  Description:
 *		type definition
 *
 ***************************************************************************
 */

#ifndef CCHARTYPE
 /* C language types */

#define CCHARTYPE	100
#define CSHORTTYPE	101
#define CINTTYPE	102
#define CLONGTYPE	103
#define CFLOATTYPE	104
#define CDOUBLETYPE	105
#define CDECIMALTYPE	107
#define CFIXCHARTYPE	108
#define CSTRINGTYPE	109
#define CDATETYPE	110
#define CMONEYTYPE	111


#define USERCOLL(x)	((x))


/*
 * Define all possible database types
 *   include C-ISAM types here as well as in isam.h
 */

#define SQLCHAR		0
#define SQLSMINT	1
#define SQLINT		2
#define SQLFLOAT	3
#define SQLSMFLOAT	4
#define SQLDECIMAL	5
#define SQLSERIAL	6
#define SQLDATE		7
#define SQLMONEY	8
#define SQLNULL		9
#define SQLTYPE		0xF	/* type mask		*/
#define SQLNONULL	0400	/* disallow nulls	*/

/* this is not a real type but a flag to show that the
 * value is from a host variable
 */
#define SQLHOST		01000

#define SIZCHAR		1
#define SIZSMINT	2
#define SIZINT		4
#define SIZFLOAT	(sizeof(double))
#define SIZSMFLOAT	(sizeof(float))
#define SIZDECIMAL	17	/* decimal(32) */
#define SIZSERIAL	4
#define SIZDATE		4
#define SIZMONEY	17	/* decimal(32) */

#define ISDECTYPE(t)	(((t)&SQLTYPE)==SQLDECIMAL || ((t)&SQLTYPE)==SQLMONEY)

#define DEFDECIMAL	9	/* default decimal(16) size */
#define DEFMONEY	9	/* default decimal(16) size */
#define DATENULL	0x80000000L

#define SYSPUBLIC	"public"


#endif /* CCHARTYPE */
